// Written by ANOQ of the Sun <anoq@HardcoreProcessing.com>

// There is no warranty of any kind and I will not be
// held responsible for any problems it may cause.

// Use at your own risk!

#include <stdlib.h>
#include <windows.h>
#include "winmain.h"

/* The original main should be redefined (in your application)
   so that it is called RunMain. This is what winmain.h
   does when you include it into your application.
   winmain.h also declares the external function RunMain */

int isWhiteSpace(char c)
{
  return (c == ' ' ||
          c == '\n' ||
          c == '\t');
}

int WinCountArgs(LPSTR lpCmdLine)
{
  int isWord = 0;
  int cnt = 0;

  if(!lpCmdLine)
    return 0;

  while(*lpCmdLine)
  {
    if(isWhiteSpace(*lpCmdLine))
    {
      if(isWord)
      {
        isWord = 0;
        cnt++;
      }
    }
    else
    {
      if(!isWord)
        isWord = 1;
    }
    lpCmdLine++;
  }
  return cnt;
}

char **WinArgv(LPSTR lpCmdLine)
{
  char **result;
  int isWord = 0;
  int cnt, cnt2 = 0;
  
  cnt = WinCountArgs(lpCmdLine);
   
  result = (char **)malloc(sizeof(char *) * cnt);
  /* FIXME: Free this again and check for out of memory!!! */

  if(!lpCmdLine)
    return result;

  /* Why don't we have higher order functions in C?
     Oh! That's the reason why we're writing ML compilers... :) */
  while(*lpCmdLine)
  {
    if(isWhiteSpace(*lpCmdLine))
    {
      if(isWord)
      {
        isWord = 0;
        cnt2++;
      }
    }
    else
    {
      if(!isWord)
      {
        isWord = 1;
        result[cnt2] = lpCmdLine;
      }
    }
    lpCmdLine++;
  }
  return result;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
  return RunMain(WinCountArgs(lpCmdLine), WinArgv(lpCmdLine));
}
